#include "./mat.h"

long double argum(zespolone z, bool czydodac=false)
{
  if (z==0) return 0;
  long double a=asinl(z.im()/z.modul());
  if (z.re()<0) if (z.im()>0) a=3.141592653589793-a; else a=-a-3.141592653589793;
  if (czydodac) if (a<0) a=a+2.0*3.141592653589793;
  return a;
  /*if (z.re()==0) z=z+0.0001;//if (z.im()>0) {return 1.570796326794897;} else {return -1.570796326794897;}
  if ((z.re()>0) && (z.im()>=0)) a=atanl(z.im()/z.re());
  if ((z.re()>0) && (z.im()<0)) a=-atanl(-z.im()/z.re());
  if ((z.re()<0) && (z.im()>=0)) a=-atanl(-z.im()/z.re())+3.141592653589793;
  if ((z.re()<0) && (z.im()<0)) a=atanl(z.im()/z.re())-3.141592653589793;
  if (a>3.141592653589793); a=a-3.141592653589793;
  return a;*/
}

zespolone liczbazarg(long double r, long double phi)
{
  return zespolone(r*cosl(phi),r*sinl(phi));
}

zespolone potega(zespolone z, long double x, bool czydodac=false)
{
  if ( (z.re()==0) && (z.im()==0)) return zespolone(0,0);
  if (x==0) return zespolone(1,0);
  long double r=expl(logl(z.modul2())*x*0.5);
  long double phi=argum(z,czydodac);
  // if (phi+galaz>2.0*M_PI) phi=phi-2.0*M_PI;
  phi=phi*x;
  return liczbazarg(r,phi);
}

bool homografia(zespolone& z, zespolone a,zespolone b,zespolone c,zespolone d)
{
  zespolone v=c*z+d;
  if (v==0) {return false;}
  z=(a*z+b)*v.odwrot();
  return true;
}

bool zukowski(zespolone& z)
{
  if (z==0) return false;
  z=(z+z.odwrot())*0.5;
  return true;
}

bool expz(zespolone& z)
{
  z=zespolone(expl(z.re())*cosl(z.im()),expl(z.re())*sinl(z.im()));
  return true;
}

bool kwadrat(zespolone& z, zespolone a, zespolone b)
{
  z=z*z+z*a+b;
  return true;

}

bool szescian(zespolone& z,zespolone a,zespolone b,zespolone c)
{
  z=z*z*z+z*z*a+z*b+c;
  return true;
}

bool digamma(zespolone& z)
{
  if (z.isNonPositiveInteger()) return false;
  zespolone w=zespolone(-0.5772156649015328606065120,0.0);
  for (int n=1;n<1000;n++) {w=w+z.odwrot()+(-1.0)/double(n); z=z+1;}
  z=w;
  return true;
}
bool nakwadrat(zespolone& z)
{
  /*  long double aa=0.5;
  long double bb=2.0/3.0;
  long double cc=1.5;
  long double dd=1.0;
  zespolone w=z*z;
  zespolone u=w;
  zespolone k=zespolone(1.0,0.0);
  for (int n=1;n<1000; n++) {k=k+w*(aa*bb/(cc*dd)); aa++; bb++; cc++; dd++; w=w*u;}
  zespolone l=zespolone(0.0,0.0);
  for (int n=1;n<50; n++) {l=l+w*(aa*bb/(cc*dd)); aa++; bb++; cc++; dd++; w=w*u;}
  if (l.modul2()>k.modul2()*0.1) return false;
  z=z*(k+l);*/
  return true; 
}
bool SC4(zespolone& z)
{
  if (z.im()<=0) return false;
  zespolone u=z;
  zespolone v=z;
  if (!arctangens(u)) return false;
  if (!arctangensh(v)) return false;
  z=v-u;
  return true; 
}
bool SC3(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w;
  zespolone u=potega(z*z-1.0,0.5,true);
  w=z+u;
  if (!logarithm(w)) return false;
  z=(z*u-w*3.0)*zespolone(0.0,-1.0)+1.5*3.141592653589793;
  return true;
}
bool logcoth(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w=z;
  if (!expz(w)) return false;
  if (w==1) return false;
  z=(w+1.0)*((w-1.0).odwrot());
  return logarithm(z);
}
bool SC2(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w=potega(z*z*(-1.0)+1.0,0.5);
  zespolone u=z+w*zespolone(0.0,1.0);
  if (!logarithm(u)) return false;
  z=(z*w+zespolone(0.0,1.0)*u)*(-1.0/1.570796326794897)-1.0;
  return true;
}
bool bezcwiartki(zespolone& z)
{
  if (z.im()<0) return false;
  z=potega(z,0.5)*(z-3.0)*zespolone(0.0,-0.5);
  return true;
}
bool arctangens(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone u=zespolone(0.0,1.0)-z;
  if (u==0) return false;
  u=(zespolone(0.0,1.0)+z)*u.odwrot();
  if (!logarithm(u)) return false;
  z=u*zespolone(0.0,0.5);
  return true;
}
bool arctangensh(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone u=zespolone(1.0,0.0)-z;
  if (u==0) return false;
  u=(z+1.0)*u.odwrot();
  if (!logarithm(u)) return false;
  z=u*0.5;
  return true;
}
bool tangens(zespolone& z)
{
  if ((z.re()>1.570796326794897*0.5) || (z.re()<-1.570796326794897*0.5)) return false;  
  zespolone w=z*zespolone(0.0,1.0);
  if (!expz(w)) return false;
  zespolone v=w.odwrot();
  if (w+v==0) return false;
  z=(w-v)*((w+v).odwrot());
  return true;
}
bool arcsine(zespolone& z)
{
  if (z.im()<=0) return false;
  zespolone w=z+potega(z*z*(-1.0)+1.0,0.5);
  if (!logarithm(w)) return false;
  z=w*zespolone(0.0,1.0);
  /*zespolone w=z*zespolone(0.0,1.0)+potega(z*z*(-1.0)+1.0,0.5);
  if (!logarithm(w)) return false;
  z=w*zespolone(0.0,-1.0);*/
  return true;
}
bool logarithm(zespolone& z, bool czydodac)
{
  if (z.im()<=0) return false;
  z=zespolone(logl(z.modul2())*0.5,argum(z,czydodac));
 return true;
}
bool squareroot(zespolone& z)
{
  if (z==0) return true;
  z=potega(z,0.5);
  return true;
}

bool przeksztalcenie(zespolone& z,zespolone a,zespolone b, zespolone c, zespolone d,int jakie)
{
  bool ok;
  switch (jakie) 
    {
    case 0: ok=homografia(z,a,b,c,d); break;
    case 1: ok=expz(z); break;
    case 2: ok=zukowski(z); break;
    case 3: ok=kwadrat(z,a,b); break;
    case 4: ok=szescian(z,a,b,c); break;
    case 5: ok=digamma(z);break;
    case 6: ok=nakwadrat(z);break;
    case 7: ok=arcsine(z); break;
    case 8: ok=logarithm(z);break;
    case 9: ok=squareroot(z); break;
    case 10: ok=tangens(z); break;
    case 11: ok=arctangens(z); break;
    case 12: ok=arctangensh(z); break;
    case 13: ok=bezcwiartki(z); break;
    case 14: ok=SC2(z); break;
    case 15: ok=logcoth(z); break;
    case 16: ok=SC3(z); break;
    case 17: ok=SC4(z); break;
    default: ok=false;
    }
  return ok;
}
char* nazwafunkcji(int n)
{
  switch (n)
    {
    case 0: return "Mobius transform z->(az+b)/(cz+d)";
    case 1: return "Exponential map z->exp(z)";
    case 2: return "Zukowski map z->(z+1/z)/2";
    case 3: return "Quadratic map z->z^2+az+b";
    case 4: return "Cubic map z->z^3+az^2+bz+c";
    case 5: return "Digamma z->dlog Gamma(z)";
    case 6: return "Experimental";
    case 7: return "z->Arc Sin(z), Im z>0";
    case 8: return "z->Log(z), Im z>0";
    case 9: return "z->z^(1/2), Im z>0";
    case 10: return "z->Tan(z), -pi/4<Re z<pi/4";
    case 11: return "z->Arc Tan(z), Im z>0";
    case 12: return "z->Ar TahH(z), Im z>0";
    case 13: return "Schwarz--Christoffel I, Im z>0";
    case 14: return "Schwarz--Christoffel II, Im z>0";
    case 15: return "z->log coth(z), Im(z)>0";
    case 16: return "Schwarz--Christoffel III, Im z>0";
    case 17: return "Schwarz--Christoffel IV, Im z>0";
    default: return "a";
    }
}
bool czygorna(int typfunkcji)
{
  switch (typfunkcji)
    {
    case 0: case 1: case 2: case 3: case 4: case 5: case 10: return false;
    default: return true;
    }
}
